'  SPIN 8-bit WAV Player Ver. 1a  (Plays only mono 8-bit WAV at 8 or 16 ksps)
'  Copyright 2007 Raymond Allen  See end of file for terms of use.


'modified by clock loop for chuff generator and putty diag output

CON _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000       '80 MHz

  Rx        = 31     'serial in from wx device
  Tx        = 30     'serial out to wx device
  
OBJ
  ser: "Parallax Serial Terminal.spin"
    
  
VAR
  long  SmokeStack1[50]
  'long  SmokeStack2[50]
  'long  SmokeStack3[50]
  'long  SmokeStack4[50]


PUB Main | loopcount
  'Play a WAV File

    ser.StartRxTx(RX, TX, 0, 115200)   'Cog #3  Parallax Serial Terminal does NOT work at receiving data 230400 for some reason.
    waitcnt(10_000_000 + cnt)   'wait 1/8 second for serial to start.

    ser.str(string(27))     'Set command mode ANSI command for putty terminal program.                                                    
    ser.str(string("[2J"))  'Clear telnet screen.
                           
    ser.str(string(27))      'Set command mode 
    ser.str(string("[1;1f")) 'Set Position  
    
  Chuff


PUB Player(pWav, PinR, PinL, rate1):bOK|n,i,nextCnt,rate,dcnt
  'Play the wav data using counter modules
  'although just mono, using both counters to play the same thing on both left and right pins

  'Set pins to output mode
  DIRA[PinR]~~                              'Set Right Pin to output
  DIRA[PinL]~~                              'Set Left Pin to output

  'Set up the counters
  CTRA:= %00110 << 26 + 0<<9 + PinR         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)
  CTRB:= %00110 << 26 + 0<<9 + PinL         'NCO/PWM Single-Ended APIN=Pin (BPIN=0 always 0)

  'get length
  n:=long[pWav+40]
  'get rate
  rate:=long[pWav+24]
  case rate
    8000:
      dcnt:=10000
    16000:
      dcnt:=5000
      'dcnt:=2000
    other:
      return false
  'jump over header
  dcnt:=rate1
  pWav+=44   'ignore rest of header (so you better have the right file format!)


  'Get ready for fast loop
  n--
  i:=0
  NextCnt:=cnt+15000

  'Play loop
  repeat i from 0 to n
    NextCnt+=dcnt   ' need this to be 5000 for 16KSPS   @ 80 MHz
    waitcnt(NextCnt)
    FRQA:=(byte[pWav+i])<<24
    FRQB:=FRQA


      'Easy high-impedance output (e.g., to "line in" input of computer or sound system)
      '
      '              R=100
      ' Prop Pin ────┳──────── Audio Out
       '               C=0.1uF
       '                
       '               Vss
  return true

Pub ChuffCal

        SampleRate1 := 480 * Pwm
          
        If SampleRate1 > 48_000 
          SampleRate := 3_600 
        Elseif SampleRate1 < 5_000
          SampleRate := 40_000        
        Else
          SampleRate := 172_800_000 / SampleRate1     
        
PUB Chuff | loopcount
  
  Pwm := 0
  Dir := 0                
  'SampleRate := 15_000
  
  Repeat
       { 'waitcnt(20_000_000 + cnt) 'Wait for 1/8 s     
        loopcount++
  
        If loopcount == 10
          cognew(Player(@ShortWhisle,26,-1,10000), @SmokeStack1)   'Cog #2, 3
          loopcount := 0
       }
               
        If Dir == 0                
            'Repeat 3
            Pwm++
            If Pwm > 99
              dir := 1
              Pwm := 100
        Else
            'Repeat 3
            Pwm--
            If Pwm < 1
              dir := 0
              Pwm := 0
        
        ChuffCal
        
        If Pwm < 11
          ser.str(string(27))      'Set command mode 
          ser.str(string("[3;3f")) 'Set Position  
          ser.Str(string("/ Idle  "))
          ser.str(string(27))      'Set command mode 
          ser.str(string("[1;1f")) 'Set Position
          'wav1.setLeftVolume(2)
          'wav1.setRightVolume(2)
          'wav1.overrideRate(16_000)
          'result := \wav1.play(string("idle.wav"), 16_000)
          ChuffCal
          
          Player(@Idle,-1,27,10000)
          
          ChuffCal
         
        Else        
          
          ser.str(string(27))      'Set command mode 
          ser.str(string("[3;3f")) 'Set Position
          ser.Str(string("/ Chuff "))
          ser.str(string(27))      'Set command mode 
          ser.str(string("[1;1f")) 'Set Position

          ChuffCal
          
          Player(@Chuff1,-1,27,SampleRate)
          
          ChuffCal            

          ser.str(string(27))      'Set command mode 
          ser.str(string("[3;3f")) 'Set Position
          ser.Str(string("-  Chuff"))
          ser.str(string(27))      'Set command mode 
          ser.str(string("[1;1f")) 'Set Position
                                   '
          ChuffCal
          
          Player(@Chuff2,-1,27,SampleRate) 
         
          ChuffCal

          ser.str(string(27))      'Set command mode 
          ser.str(string("[3;3f")) 'Set Position
          ser.Str(string("\ Chuff "))
          ser.str(string(27))      'Set command mode 
          ser.str(string("[1;1f")) 'Set Position
          
          ChuffCal                         '
          
          Player(@Chuff3,-1,27,SampleRate)
          
          ChuffCal
                      
          ser.str(string(27))      'Set command mode 
          ser.str(string("[3;3f")) 'Set Position
          ser.Str(string("|  Chuff"))
          ser.str(string(27))      'Set command mode 
          ser.str(string("[1;1f")) 'Set Position
                                   '
          ChuffCal
          Player(@Chuff4,-1,27,SampleRate)
          ChuffCal
                   

    
   
        ser.str(string(27))      'Set command mode 
        ser.str(string("[10;3f")) 'Set Position
        ser.Str(string("SampleRate: "))
        ser.dec(SampleRate)
        ser.Str(string("    "))

        ser.str(string(27))      'Set command mode 
        ser.str(string("[9;3f")) 'Set Position
        ser.Str(string("Pwm: "))
        ser.dec(Pwm)
        ser.Str(string("    "))            

        
DAT



SampleRate    long 0
SampleRate1   long 0
Pwm           byte 0
Dir           byte 0


Chuff1 long
File "8kc1.wav"           '   <---  put your 8-bit PCM mono 16000 or 8000 sample/second WAV filename here

Chuff2 long
File "8kc2.wav"           '   <---  put your 8-bit PCM mono 16000 or 8000 sample/second WAV filename here

Chuff3 long
File "8kc3.wav"           '   <---  put your 8-bit PCM mono 16000 or 8000 sample/second WAV filename here

Chuff4 long
File "8kc4.wav"           '   <---  put your 8-bit PCM mono 16000 or 8000 sample/second WAV filename here

Idle long
File "8kIdle.wav"           '   <---  put your 8-bit PCM mono 16000 or 8000 sample/second WAV filename here

'ShortWhisle long
'File "Wstl.wav"
{{
                            TERMS OF USE: MIT License

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}
